<template>
    <Page>
        <ActionBar class="header">
            <StackLayout>
                <FlexboxLayout
                    flexDirection="row"
                    justifyContent="space-between" class="navbar"
                >
                    <Image
                        src="~/assets/images/menu.png"
                        class="menu"
                        stretch="fill"
                        @tap="$refs.drawer.nativeView.showDrawer()"
                    ></Image>
                    <Image
                        src="~/assets/images/logo.png"
                        class="logo"
                        stretch="fill"
                    ></Image>
                    <Image
                        src="~/assets/images/cloche.png"
                        class="bell"
                        stretch="fill"
                    ></Image>
                </FlexboxLayout>
            </StackLayout>
        </ActionBar>

        <RadSideDrawer ref="drawer">
            <StackLayout ~drawerContent backgroundColor="#ffffff">
                <DrawerContent/>
            </StackLayout>

            <StackLayout ~mainContent>
                <FlexboxLayout alignItems="center" class="back-button">
                    <Image src="~/assets/images/back.png" class="icon-margin" stretch="fill"></Image>
                    <Label class="back" text="Retour" @tap="$navigateBack"/>
                </FlexboxLayout>
                <GridLayout columns="*, 80" rows="*, 350">
                    <ScrollView orientation="vertical" colSpan="2" rowSpan="2">
                        <FlexboxLayout flexDirection="column" class="full-height">

                            <GridLayout height="300">
                                <Carousel
                                    id="carousel"
                                    ios:indicatorOffset="0,25"
                                    ios:finite="true"
                                    ios:bounce="false"
                                    showIndicator="true"
                                    indicatorAnimation="SWAP"
                                    indicatorColor="#339E33"
                                    indicatorColorUnselected="#7D7D7D"
                                    indicatorOffset="0,25"
                                    height="90%"
                                    width="75%"
                                >
                                    <CarouselItem id="slide1" verticalAlignment="middle">
                                        <Image src="~/assets/images/maison.png" class="img-annonce"
                                               stretch="fill"></Image>
                                    </CarouselItem>

                                    <CarouselItem id="slide2" verticalAlignment="middle">
                                        <Image src="~/assets/images/maison2.png" class="img-annonce"
                                               stretch="fill"></Image>
                                    </CarouselItem>

                                    <CarouselItem id="slide3" verticalAlignment="middle">
                                        <Image src="~/assets/images/maison.png" class="img-annonce"
                                               stretch="fill"></Image>
                                    </CarouselItem>

                                </Carousel>
                            </GridLayout>

                            <Button text="Réserver" class="resev-button" @tap="reserv(listOfItems.adv_id)"/>

                            <Label class="title" :text="listOfItems.adv_name"/>
                            <FlexboxLayout flexDirection="column" class="annonce-content">
                                <Label class="price-annonce" :text="'Prix : ' + listOfItems.adv_price + ' €/jour'"/>
                                <Label class="nbCrit-annonce"
                                       :text="'Nombre de personnes : ' + listOfItems.adv_tenants"/>
                                <Label class="address-annonce"
                                       :text="listOfItems.adv_adress + ', ' + listOfItems.adv_postal + ' ' + listOfItems.adv_city"/>
                                <Label class="description-annonce" :text="listOfItems.adv_describe" textWrap="true"/>
                            </FlexboxLayout>


                            <Label class="title" text="Activitées à proximitées"/>
                            <FlexboxLayout flexDirection="row" class="activity-content"
                                           v-if="this.activityList.length < 4">
                                <FlexboxLayout flexDirection="column" class="activity" v-for="activity in activityList">
                                    <Image src="~/assets/images/maison.png" class="img-activity" stretch="fill"
                                           @tap="selectActivity(activity.act_id)"></Image>
                                    <Label class="title-activity" :text="activity.act_name" textWrap="true"/>
                                </FlexboxLayout>
                            </FlexboxLayout>
                            <ScrollView orientation="horizontal" v-else>
                                <FlexboxLayout flexDirection="row" class="activity-content">
                                    <FlexboxLayout flexDirection="column" class="activity"
                                                   v-for="activity in activityList"
                                                   @tap="selectActivity(activity.act_id)">
                                        <Image src="~/assets/images/maison.png" class="img-activity"
                                               stretch="fill"></Image>
                                        <Label class="title-activity" :text="activity.act_name" textWrap="true"/>
                                    </FlexboxLayout>
                                </FlexboxLayout>
                            </ScrollView>

                            <Label class="title" text="Commentaires de l'annonce"/>

                            <FlexboxLayout flexDirection="column" class="comment-content" v-for="com in comList">
                                <Label class="user-com" :text="com.com_usr_firstName + ' ' + com.com_usr_lastName"/>
                                <Label class="text-com" :text="com.com_text" textWrap="true"/>
                            </FlexboxLayout>
                        </FlexboxLayout>

                    </ScrollView>
                    <FlexboxLayout alignItems="flex-end" flexDirection="column-reverse" class="button-float" row="1"
                                   colSpan="2"
                                   rowSpan="2">
                        <Label text="+" width="70" height="70" fontSize="38" borderRadius="50" backgroundColor="#7D7D7D"
                               @tap="floatButton" class="button-float-content"/>
                        <FlexboxLayout class="content" alignItems="flex-end" flexDirection="column" v-if="floatMenu"
                                       backgroundColor="#7D7D7D">
                            <Label text="ajouter un commentaire" height="30" class="content-txt" @tap="showModal()"/>
                        </FlexboxLayout>
                    </FlexboxLayout>
                </GridLayout>


            </StackLayout>
        </RadSideDrawer>
    </Page>
</template>

<script>
import {Http} from "@nativescript/core";

const carousel = require('nativescript-carousel');
import DrawerContent from "./DrawerContent";
import AddComment from "./AddComment";

export default {
    props: ['idAdvert'],
    components: {
        DrawerContent,
    },
    data() {
        return {
            listOfItems: {},
            activityList: [],
            comList: [],
            floatMenu: false,
        }
    },
    mounted() {
        this.getAdvert()
        this.getActivity()
        this.getCommentary()
    },
    methods: {
        floatButton() {
            this.floatMenu = !this.floatMenu
        },
        showModal() {
            this.$showModal(AddComment, {props: {idAdvert: this.idAdvert}}).then(() => {
                this.floatMenu = false;
                this.comList = [];
                this.getCommentary();
            });
        },
        selectActivity(id) {
            this.$navigateTo(this.$routes.DetailsActivity, {
                props: {
                    idActivity: id,
                    idAdvert: this.idAdvert
                }
            });
        },
        reserv(id) {
            this.$navigateTo(this.$routes.CreateReserve, {
                props: {
                    idAdvert: id,
                }
            });
        },
        async getAdvert() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getAdvertbyId",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    adv_id: this.idAdvert
                }),
            })
            var result = response.content.toJSON();
            this.listOfItems = result.selectedAdvert[0];
        },
        async getActivity() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getActivityByID",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    adv_id: this.idAdvert
                }),
            })
            var result = response.content.toJSON();
            for (let activity in result.selectedActivity) {
                this.activityList.push(result.selectedActivity[activity]);
            }
        },
        async getCommentary() {
            const response = await Http.request({
                url: "https://api.atypikhouse.art/getCommentarybyAdvert",
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Access-Control-Allow-Origin": "*",
                },
                content: JSON.stringify({
                    com_adv_id: this.idAdvert
                }),
            })
            var result = response.content.toJSON();
            for (let commentary in result.selectedCommentary) {
                this.comList.push(result.selectedCommentary[commentary]);
            }
        },
    }
}
</script>

<style scoped>
.header {
    background-image: url("~/assets/images/header.png");
    background-size: cover;
    background-repeat: no-repeat;
    background-position: center;
    width: 100%;
}

.navbar {
    height: 120;
    width: 100%;
    padding-top: 30;
}

.menu {
    text-align: left;
    width: 40;
    margin-top: 13vh;
    margin-bottom: 40vh;
}

.logo {
    width: 70;
    height: 90px;
    margin-bottom: 20vh;
    justify-self: center;
}

.bell {
    text-align: right;
    width: 40vw;
    margin-top: 13vh;
    margin-bottom: 40vh;
    margin-right: 10;
}

.back-button {
    margin-left: 10;
    margin-top: 10;
}

.back {
    text-align: left;
    color: #2d2d2d;
}

.button-float {
    margin-right: 30vw;
    margin-bottom: 30vh;
}

.button-float-content {
    color: white;
    padding-left: 25vw;
    padding-top: 8vh;
}

.content {
    height: 80;
    padding-top: 20;
    margin-bottom: -50;
    border-radius: 15;
}

.content-txt {
    color: white;
    padding-top: 5vh;
    padding-left: 10vw;
    padding-right: 10vw;
    z-index: 1000;
}

.icon-margin {
    margin-right: 10;
    width: 16;
    height: 16;
}

.full-height {
    height: max-content;
    margin-left: 20vw;
    margin-right: 20vw;
    margin-top: 30vh;
}

.img-annonce {
    width: 100%;
    height: 100%;
}

.resev-button {
    width: 40%;
    border: 5px solid #2D2D2D;
    box-sizing: border-box;
    color: #2d2d2d;
    background-color: white;
    border-color: #7d7d7d;
    border-width: 1;
    border-radius: 10;
    text-transform: uppercase;
    letter-spacing: 0.1;
    font-size: 10;
    margin: 15 100vw;
}

.title {
    text-align: left;
    font-size: 25px;
    color: #2d2d2d;
    margin-bottom: 10;
    margin-top: 10;
}

.annonce-content {
    flex-wrap: wrap;
    margin-bottom: 10;
    margin-top: 10;
}

.price-annonce {
    text-align: left;
    font-size: 18px;
    color: #2d2d2d;
    margin-bottom: 5;
}

.address-annonce {
    font-size: 16px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 5;
}

.nbCrit-annonce {
    font-size: 16px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 5;
}

.description-annonce {
    font-size: 16px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 5;
}

.activity {
    width: 100;
    margin: 10;
    text-align: left;
}

.img-activity {
    width: 50;
    height: 100;
}

.title-activity {
    font-size: 20px;
    text-align: center;
    color: #2d2d2d;
    margin-bottom: 5;
    margin-top: 10;
}

.comment-content {
    flex-wrap: wrap;
    margin-bottom: 10;
    margin-top: 10;
}

.user-com {
    font-size: 16px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
    margin-bottom: 10;
    margin-top: 10;
}

.text-com {
    font-size: 14px;
    color: #7d7d7d;
    display: flex;
    flex-wrap: wrap;
}

</style>
